#!/bin/sh

# $1 -> work dir
# $2 -> out file

if [ $# -eq 2 ]; then
		
	ROOT_DIR=$1
	DST=$2

   	if [ ! -f project/$ROOT_DIR/tools/cmpfastsim/linux/cmpfastsim ]; then
	    echo "Appliccation of the fast compiled simulator doesn't exist"
	    exit
	fi
					
	#for linux define the directory with libraries
	export LD_LIBRARY_PATH=../../../../../lib 2>&1

	# for windows define the directory with libraries
	export PATH=../../../../../lib 2>&1
	
	# !!!! exception - the working directory is the project/$ROOT_DIR/tools/cmpfastsim/linux/
	# because of the binary CPU application's file location
	cd project/$ROOT_DIR/tools/cmpfastsim/linux/
	
	#run simulator
	./cmpfastsim -o ../../../../../$DST 2>&1
else
	DSTPROG=`find $0 -printf %f`;
    echo "Usage: $DSTPROG <project> <output file>"
fi
